---
title: Debugger
slug: Tools/Debugger-API/Debugger
---
<div>{{ToolsSidebar}}</div><h1 id="The_Debugger_Object">The Debugger Object</h1>

<p>When called as a constructor, the <code>Debugger</code> object creates a new <code>Debugger</code> instance.</p>

<dl>
 <dt><code>new Debugger([<em>global</em>, …])</code></dt>
 <dd>Create a debugger object, and apply its <a href="Debugger#addDebuggee" title="The Debugger object: addDebuggee"><code>addDebuggee</code></a> method to each of the given<em>global</em> objects to add them as the initial debuggees.</dd>
</dl>

<h2 id="Accessor_Properties_of_the_Debugger_Prototype_Object">Accessor Properties of the Debugger Prototype Object</h2>

<p>A <code>Debugger</code> instance inherits the following accessor properties from its prototype:</p>

<dl>
 <dt><code>enabled</code></dt>
 <dd>
 <p>A boolean value indicating whether this <code>Debugger</code> instance’s handlers, breakpoints, and the like are currently enabled. It is an accessor property with a getter and setter: assigning to it enables or disables this <code>Debugger</code> instance; reading it produces true if the instance is enabled, or false otherwise. This property is initially <code>true</code> in a freshly created <code>Debugger</code> instance.</p>

 <p>This property gives debugger code a single point of control for disentangling itself from the debuggee, regardless of what sort of events or handlers or “points” we add to the interface.</p>
 </dd>
 <dt><code>allowUnobservedAsmJS</code></dt>
 <dd>
 <p>A boolean value indicating whether asm.js code running inside this <code>Debugger</code> instance’s debuggee globals is invisible to Debugger API handlers and breakpoints. Setting this to <code>false</code> inhibits the ahead-of-time asm.js compiler and forces asm.js code to run as normal JavaScript. This is an accessor property with a getter and setter. It is initially <code>false</code> in a freshly created <code>Debugger</code> instance.</p>

 <p>Setting this flag to <code>true</code> is intended for uses of subsystems of the Debugger API (e.g, <a href="Debugger.Source"><code>Debugger.Source</code></a>) for purposes other than step debugging a target JavaScript program.</p>
 </dd>
 <dt><code>allowWasmBinarySource</code></dt>
 <dd>A boolean value indicating whether WebAssembly sources will be available in binary form. The WebAssembly text generation will be disabled.</dd>
 <dt><code>collectCoverageInfo</code></dt>
 <dd>
 <p>A boolean value indicating whether code coverage should be enabled inside each debuggee of this <code>Debugger</code> instance. Changing this flag value will recompile all JIT code to add or remove code coverage instrumentation. Changing this flag when any frame of the debuggee is currently active on the stack will produce an exception.</p>

 <p>Setting this to <code>true</code> enables code coverage instrumentation, which can be accessed via the <a href="Debugger.Script"><code>Debugger.Script</code></a> <code>getOffsetsCoverage</code> function. In some cases, the code coverage might expose information which pre-date the modification of this flag. Code coverage reports are monotone, thus one can take a snapshot when the Debugger is enabled, and output the difference.</p>

 <p>Setting this to <code>false</code> prevents this <code>Debugger</code> instance from requiring any code coverage instrumentation, but it does not guarantee that the instrumentation is not present.</p>
 </dd>
 <dt><code>uncaughtExceptionHook</code></dt>
 <dd>
 <p>Either <code>null</code> or a function that SpiderMonkey calls when a call to a debug event handler, breakpoint handler, or similar function throws some exception, which we refer to as<em>debugger-exception</em> here. Exceptions thrown in the debugger are not propagated to debuggee code; instead, SpiderMonkey calls this function, passing<em>debugger-exception</em> as its sole argument and the <code>Debugger</code> instance as the <code>this</code> value. This function should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a>, which determines how the debuggee should continue.</p>

 <p>If the uncaught exception hook itself throws an exception,<em>uncaught-hook-exception</em>, SpiderMonkey throws a new error object,<em>confess-to-debuggee-exception</em>, to the debuggee whose message blames the debugger, and includes textual descriptions of<em>uncaught-hook-exception</em> and the original<em>debugger-exception</em>.</p>

 <p>If <code>uncaughtExceptionHook</code>’s value is <code>null</code>, SpiderMonkey throws an exception to the debuggee whose message blames the debugger, and includes a textual description of<em>debugger-exception</em>.</p>

 <p>Assigning anything other than a callable value or <code>null</code> to this property throws a <code>TypeError</code> exception.</p>

 <p>(This is not an ideal way to handle debugger bugs, but the hope here is that some sort of backstop, even if imperfect, will make life easier for debugger developers. For example, an uncaught exception hook may have access to browser-level features like the <code>alert</code> function, which this API’s implementation does not, making it possible to present debugger errors to the developer in a way suited to the context.)</p>
 </dd>
</dl>

<h2 id="Debugger_Handler_Functions">Debugger Handler Functions</h2>

<p>Each <code>Debugger</code> instance inherits accessor properties with which you can store handler functions for SpiderMonkey to call when given events occur in debuggee code.</p>

<p>When one of the events described below occurs in debuggee code, the engine pauses the debuggee and calls the corresponding debugging handler on each <code>Debugger</code> instance that is observing the debuggee. The handler functions receive the <code>Debugger</code> instance as their <code>this</code> value. Most handler functions can return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> indicating how the debuggee’s execution should proceed.</p>

<p>On a new <code>Debugger</code> instance, each of these properties is initially <code>undefined</code>. Any value assigned to a debugging handler must be either a function or <code>undefined</code>; otherwise a <code>TypeError</code> is thrown.</p>

<p>Handler functions run in the same thread in which the event occurred. They run in the compartment to which they belong, not in a debuggee compartment.</p>

<dl>
 <dt><code>onNewScript(<em>script</em>,<em>global</em>)</code></dt>
 <dd>
 <p>New code, represented by the <a href="Debugger.Script"><code>Debugger.Script</code></a> instance<em>script</em>, has been loaded in the scope of the debuggees.</p>

 <p>This method’s return value is ignored.</p>
 </dd>
 <dt><code>onNewPromise(<em>promise</em>)</code></dt>
 <dd>
 <p>A new Promise object, referenced by the <a href="Debugger.Object"><code>Debugger.Object</code></a> instance <em>promise</em>, has been allocated in the scope of the debuggees. The Promise’s allocation stack can be obtained using the <em>promiseAllocationStack</em> accessor property of the <a href="Debugger.Object"><code>Debugger.Object</code></a> instance <em>promise</em>.</p>

 <p>This handler method should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> specifying how the debuggee’s execution should proceed. However, note that a <code>{ return:<em>value</em> }</code> resumption value is treated like <code>undefined</code> (“continue normally”);<em>value</em> is ignored.</p>
 </dd>
 <dt><code>onPromiseSettled(<em>promise</em>)</code></dt>
 <dd>
 <p>A Promise object, referenced by the <a href="Debugger.Object"><code>Debugger.Object</code></a> instance <em>promise</em> that was allocated within a debuggee scope, has settled (either fulfilled or rejected). The Promise’s state, fulfillment or rejection value, and the allocation and resolution stacks can be obtained using the Promise-related accessor properties of the <a href="Debugger.Object"><code>Debugger.Object</code></a> instance <em>promise</em>.</p>

 <p>This handler method should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> specifying how the debuggee’s execution should proceed. However, note that a <code>{ return:<em>value</em> }</code> resumption value is treated like <code>undefined</code> (“continue normally”);<em>value</em> is ignored.</p>
 </dd>
 <dt><code>onDebuggerStatement(<em>frame</em>)</code></dt>
 <dd>Debuggee code has executed a<em>debugger</em> statement in<em>frame</em>. This method should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> specifying how the debuggee’s execution should proceed.</dd>
 <dt><code>onEnterFrame(<em>frame</em>)</code></dt>
 <dd>
 <p>The stack frame<em>frame</em> is about to begin executing code. (Naturally,<em>frame</em> is currently the youngest <a href="Debugger.Frame#visible-frames" title="Debugger.Frame: Visible Frames">visible frame</a>.) This method should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> specifying how the debuggee’s execution should proceed.</p>

 <p>SpiderMonkey only calls <code>onEnterFrame</code> to report <a href="Debugger.Frame#visible-frames" title="Debugger.Frame: Visible Frames">visible</a>, non-<code>"debugger"</code> frames.</p>
 </dd>
 <dt><code>onExceptionUnwind(<em>frame</em>,<em>value</em>)</code></dt>
 <dd>
 <p>The exception<em>value</em> has been thrown, and has propagated to<em>frame</em>;<em>frame</em> is the youngest remaining stack frame, and is a debuggee frame. This method should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> specifying how the debuggee’s execution should proceed. If it returns <code>undefined</code>, the exception continues to propagate as normal: if control in <code>frame</code> is in a <code>try</code> block, control jumps to the corresponding <code>catch</code> or <code>finally</code> block; otherwise,<em>frame</em> is popped, and the exception propagates to<em>frame</em>’s caller.</p>

 <p>When an exception’s propagation causes control to enter a <code>finally</code> block, the exception is temporarily set aside. If the <code>finally</code> block finishes normally, the exception resumes propagation, and the debugger’s <code>onExceptionUnwind</code> handler is called again, in the same frame. (The other possibility is for the <code>finally</code> block to exit due to a <code>return</code>, <code>continue</code>, or <code>break</code> statement, or a new exception. In those cases the old exception does not continue to propagate; it is discarded.)</p>

 <p>This handler is not called when unwinding a frame due to an over-recursion or out-of-memory exception.</p>
 </dd>
 <dt><code>sourceHandler(<em>ASuffusionOfYellow</em>)</code></dt>
 <dd>This method is never called. If it is ever called, a contradiction has been proven, and the debugger is free to assume that everything is true.</dd>
 <dt><code>onError(<em>frame</em>,<em>report</em>)</code></dt>
 <dd>
 <p>SpiderMonkey is about to report an error in<em>frame</em>.<em>Report</em> is an object describing the error, with the following properties:</p>

 <dl>
  <dt><code>message</code></dt>
  <dd>The fully formatted error message.</dd>
  <dt><code>file</code></dt>
  <dd>If present, the source file name, URL, etc. (If this property is present, the<em>line</em> property will be too, and vice versa.)</dd>
  <dt><code>line</code></dt>
  <dd>If present, the source line number at which the error occurred.</dd>
  <dt><code>lineText</code></dt>
  <dd>If present, this is the source code of the offending line.</dd>
  <dt><code>offset</code></dt>
  <dd>The index of the character within lineText at which the error occurred.</dd>
  <dt><code>warning</code></dt>
  <dd>Present and true if this is a warning; absent otherwise.</dd>
  <dt><code>strict</code></dt>
  <dd>Present and true if this error or warning is due to the strict option (not to be confused with ES strict mode)</dd>
  <dt><code>exception</code></dt>
  <dd>Present and true if an exception will be thrown; absent otherwise.</dd>
  <dt><code>arguments</code></dt>
  <dd>An array of strings, representing the arguments substituted into the error message.</dd>
 </dl>

 <p>This method’s return value is ignored.</p>
 </dd>
 <dt><code>onNewGlobalObject(global)</code></dt>
 <dd>
 <p>A new global object,<em>global</em>, has been created.</p>

 <p>This handler method should return a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a> specifying how the debuggee’s execution should proceed. However, note that a <code>{ return:<em>value</em> }</code> resumption value is treated like <code>undefined</code> (“continue normally”);<em>value</em> is ignored. (Allowing the handler to substitute its own value for the new global object doesn’t seem useful.)</p>

 <p>This handler method is only available to debuggers running in privileged code (“chrome”, in Firefox). Most functions provided by this <code>Debugger</code> API observe activity in only those globals that are reachable by the API’s user, thus imposing capability-based restrictions on a <code>Debugger</code>’s reach. However, the <code>onNewGlobalObject</code> method allows the API user to monitor all global object creation that occurs anywhere within the JavaScript system (the “JSRuntime”, in SpiderMonkey terms), thereby escaping the capability-based limits. For this reason, <code>onNewGlobalObject</code> is only available to privileged code.</p>
 </dd>
</dl>

<h2 id="Function_Properties_of_the_Debugger_Prototype_Object">Function Properties of the Debugger Prototype Object</h2>

<p>The functions described below may only be called with a <code>this</code> value referring to a <code>Debugger</code> instance; they may not be used as methods of other kinds of objects.</p>

<dl>
 <dt><code id="addDebuggee">addDebuggee(<em>global</em>)</code></dt>
 <dd>
 <p>Add the global object designated by<em>global</em> to the set of global objects this <code>Debugger</code> instance is debugging. If the designated global is already a debuggee, this has no effect. Return this <code>Debugger</code>’s <a href="Debugger.Object"><code>Debugger.Object</code></a> instance referring to the designated global.</p>

 <p>The value<em>global</em> may be any of the following:</p>

 <ul>
  <li>
   <p>A global object.</p>
  </li>
  <li>
   <p>An HTML5 <code>WindowProxy</code> object (an “outer window”, in Firefox terminology), which is treated as if the <code>Window</code> object of the browsing context’s active document (the “inner window”) were passed.</p>
  </li>
  <li>
   <p>A cross-compartment wrapper of an object; we apply the prior rules to the wrapped object.</p>
  </li>
  <li>
   <p>A <a href="Debugger.Object"><code>Debugger.Object</code></a> instance belonging to this <code>Debugger</code> instance; we apply the prior rules to the referent.</p>
  </li>
  <li>
   <p>Any other sort of value is treated as a <code>TypeError</code>. (Note that each rule is only applied once in the process of resolving a given<em>global</em> argument. Thus, for example, a <a href="Debugger.Object"><code>Debugger.Object</code></a> referring to a second <a href="Debugger.Object"><code>Debugger.Object</code></a> which refers to a global does not designate that global for the purposes of this function.)</p>
  </li>
 </ul>

 <p>The global designated by<em>global</em> must be in a different compartment than this <code>Debugger</code> instance itself. If adding the designated global’s compartment would create a cycle of debugger and debuggee compartments, this method throws an error.</p>

 <p>This method returns the <a href="Debugger.Object"><code>Debugger.Object</code></a> instance whose referent is the designated global object.</p>

 <p>The <code>Debugger</code> instance does not hold a strong reference to its debuggee globals: if a debuggee global is not otherwise reachable, then it is dropped from the <code>Debugger</code>’s set of debuggees. (Naturally, the <a href="Debugger.Object"><code>Debugger.Object</code></a> instance this method returns does hold a strong reference to the added global.)</p>

 <p>If this debugger is <a href="Debugger.Memory#trackingallocationsites" title="Debugger.Memory: trackingAllocationSites">tracking allocation sites</a> and cannot track allocation sites for<em>global</em>, this method throws an <code>Error</code>.</p>
 </dd>
 <dt><code>addAllGlobalsAsDebuggees()</code></dt>
 <dd>
 <p>This method is like <a href="Debugger#addDebuggee" title="The Debugger object: addDebuggee"><code>addDebuggee</code></a>, but adds all the global objects from all compartments to this <code>Debugger</code> instance’s set of debuggees. Note that it skips this debugger’s compartment.</p>

 <p>If this debugger is <a href="Debugger.Memory#trackingallocationsites" title="Debugger.Memory: trackingAllocationSites">tracking allocation sites</a> and cannot track allocation sites for some global, this method throws an <code>Error</code>. Otherwise this method returns <code>undefined</code>.</p>

 <p>This method is only available to debuggers running in privileged code (“chrome”, in Firefox). Most functions provided by this <code>Debugger</code> API observe activity in only those globals that are reachable by the API’s user, thus imposing capability-based restrictions on a <code>Debugger</code>’s reach. However, the <code>addAllGlobalsAsDebuggees</code> method allows the API user to monitor all global object creation that occurs anywhere within the JavaScript system (the “JSRuntime”, in SpiderMonkey terms), thereby escaping the capability-based limits. For this reason, <code>addAllGlobalsAsDebuggees</code> is only available to privileged code.</p>
 </dd>
 <dt><code>removeDebuggee(<em>global</em>)</code></dt>
 <dd>
 <p>Remove the global object designated by<em>global</em> from this <code>Debugger</code> instance’s set of debuggees. Return <code>undefined</code>.</p>

 <p>This method interprets<em>global</em> using the same rules that <a href="Debugger#addDebuggee" title="The Debugger object: addDebuggee"><code>addDebuggee</code></a> does.</p>

 <p>Removing a global as a debuggee from this <code>Debugger</code> clears all breakpoints that belong to that <code>Debugger</code> in that global.</p>
 </dd>
 <dt><code>removeAllDebuggees()</code></dt>
 <dd>Remove all the global objects from this <code>Debugger</code> instance’s set of debuggees. Return <code>undefined</code>.</dd>
 <dt><code>hasDebuggee(<em>global</em>)</code></dt>
 <dd>
 <p>Return <code>true</code> if the global object designated by<em>global</em> is a debuggee of this <code>Debugger</code> instance.</p>

 <p>This method interprets<em>global</em> using the same rules that <a href="Debugger#addDebuggee" title="The Debugger object: addDebuggee"><code>addDebuggee</code></a> does.</p>
 </dd>
 <dt><code>getDebuggees()</code></dt>
 <dd>
 <p>Return an array of distinct <a href="Debugger.Object"><code>Debugger.Object</code></a> instances whose referents are all the global objects this <code>Debugger</code> instance is debugging.</p>

 <p>Since <code>Debugger</code> instances don’t hold strong references to their debuggee globals, if a debuggee global is otherwise unreachable, it may be dropped at any moment from the array this method returns.</p>
 </dd>
 <dt><code>getNewestFrame()</code></dt>
 <dd>Return a <a href="Debugger.Frame"><code>Debugger.Frame</code></a> instance referring to the youngest <a href="Debugger.Frame#visible-frames" title="Debugger.Frame: Visible Frames">visible frame</a> currently on the calling thread’s stack, or <code>null</code> if there are no visible frames on the stack.</dd>
 <dt><code>findSources([<em>query</em>])<em>(not yet implemented)</em></code></dt>
 <dd>
 <p>Return an array of all <a href="Debugger.Source"><code>Debugger.Source</code></a> instances matching<em>query</em>. Each source appears only once in the array.<em>Query</em> is an object whose properties restrict which sources are returned; a source must meet all the criteria given by<em>query</em> to be returned. If<em>query</em> is omitted, we return all sources of all debuggee scripts.</p>

 <p><em>Query</em>may have the following properties:</p>

 <dl>
  <dt><code>url</code></dt>
  <dd>The source’s <code>url</code> property must be equal to this value.</dd>
  <dt><code>global</code></dt>
  <dd>The source must have been evaluated in the scope of the given global object. If this property’s value is a <a href="Debugger.Object"><code>Debugger.Object</code></a> instance belonging to this <code>Debugger</code> instance, then its referent is used. If the object is not a global object, then the global in whose scope it was allocated is used.</dd>
 </dl>

 <p>Note that the result may include sources that can no longer ever be used by the debuggee: say, eval code that has finished running, or source for unreachable functions. Whether such sources appear can be affected by the garbage collector’s behavior, so this function’s result is not entirely deterministic.</p>
 </dd>
 <dt><code>findScripts([<em>query</em>])</code></dt>
 <dd>
 <p>Return an array of <a href="Debugger.Script"><code>Debugger.Script</code></a> instances for all debuggee scripts matching<em>query</em>. Each instance appears only once in the array.<em>Query</em> is an object whose properties restrict which scripts are returned; a script must meet all the criteria given by<em>query</em> to be returned. If<em>query</em> is omitted, we return the <a href="Debugger.Script"><code>Debugger.Script</code></a> instances for all debuggee scripts.</p>

 <p><em>Query</em>may have the following properties:</p>

 <dl>
  <dt><code>url</code></dt>
  <dd>The script’s <code>url</code> property must be equal to this value.</dd>
  <dt><code>source</code></dt>
  <dd>The script’s <code>source</code> property must be equal to this value.</dd>
  <dt><code>line</code></dt>
  <dd>The script must at least partially cover the given source line. If this property is present, the <code>url</code> property must be present as well.</dd>
  <dt><code>column</code></dt>
  <dd>The script must include given column on the line given by the <code>line</code> property. If this property is present, the <code>url</code> and <code>line</code> properties must both be present as well.</dd>
  <dt><code>innermost</code></dt>
  <dd>If this property is present and true, the script must be the innermost script covering the given source location; scripts of enclosing code are omitted.</dd>
  <dt><code>global</code></dt>
  <dd>The script must be in the scope of the given global object. If this property’s value is a <a href="Debugger.Object"><code>Debugger.Object</code></a> instance belonging to this <code>Debugger</code> instance, then its referent is used. If the object is not a global object, then the global in whose scope it was allocated is used.</dd>
 </dl>

 <p>All properties of<em>query</em> are optional. Passing an empty object returns all debuggee code scripts.</p>

 <p>Note that the result may include <a href="Debugger.Script"><code>Debugger.Script</code></a> instances for scripts that can no longer ever be used by the debuggee, say, those for eval code that has finished running, or unreachable functions. Whether such scripts appear can be affected by the garbage collector’s behavior, so this function’s behavior is not entirely deterministic.</p>
 </dd>
 <dt><code>findObjects([<em>query</em>])</code></dt>
 <dd>
 <p>Return an array of <a href="Debugger.Object"><code>Debugger.Object</code></a> instances referring to each live object allocated in the scope of the debuggee globals that matches <em>query</em>. Each instance appears only once in the array. <em>Query</em> is an object whose properties restrict which objects are returned; an object must meet all the criteria given by <em>query</em> to be returned. If <em>query</em> is omitted, we return the <a href="Debugger.Object"><code>Debugger.Object</code></a> instances for all objects allocated in the scope of debuggee globals.</p>

 <p>The <em>query</em> object may have the following properties:</p>

 <dl>
  <dt><code>class</code></dt>
  <dd>If present, only return objects whose internal <code>[[Class]]</code>’s name matches the given string. Note that in some cases, the prototype object for a given constructor has the same <code>[[Class]]</code> as the instances that refer to it, but cannot itself be used as a valid instance of the class. Code gathering objects by class name may need to examine them further before trying to use them.</dd>
 </dl>

 <p>All properties of <em>query</em> are optional. Passing an empty object returns all objects in debuggee globals.</p>

 <p>Unlike <code>findScripts</code>, this function is deterministic and will never return <a href="Debugger.Object"><code>Debugger.Object</code>s</a> referring to previously unreachable objects that had not been collected yet.</p>
 </dd>
 <dt><code>clearBreakpoint(<em>handler</em>)</code></dt>
 <dd>Remove all breakpoints set in this <code>Debugger</code> instance that use<em>handler</em> as their handler. Note that, if breakpoints using other handler objects are set at the same location(s) as<em>handler</em>, they remain in place.</dd>
 <dt><code>clearAllBreakpoints()</code></dt>
 <dd>Remove all breakpoints set using this <code>Debugger</code> instance.</dd>
 <dt><code>findAllGlobals()</code></dt>
 <dd>
 <p>Return an array of <a href="Debugger.Object"><code>Debugger.Object</code></a> instances referring to all the global objects present in this JavaScript instance.</p>

 <p>The results of this call can be affected in non-deterministic ways by the details of the JavaScript implementation. The array may include <a href="Debugger.Object"><code>Debugger.Object</code></a> instances referring to global objects that are not actually reachable by the debuggee or any other code in the system. (Naturally, once the function has returned, the array’s <a href="Debugger.Object"><code>Debugger.Object</code></a> instances strongly reference the globals they refer to.)</p>

 <p>This handler method is only available to debuggers running in privileged code (“chrome”, in Firefox). Most functions provided by this <code>Debugger</code> API observe activity in only those globals that are reachable by the API’s user, thus imposing capability-based restrictions on a <code>Debugger</code>’s reach. However, <code>findAllGlobals</code> allows the API user to find all global objects anywhere within the JavaScript system (the “JSRuntime”, in SpiderMonkey terms), thereby escaping the capability-based limits. For this reason, <code>findAllGlobals</code> is only available to privileged code.</p>
 </dd>
 <dt><code>makeGlobalObjectReference(<em>global</em>)</code></dt>
 <dd>Return the <a href="Debugger.Object"><code>Debugger.Object</code></a> whose referent is the global object designated by<em>global</em>, without adding the designated global as a debuggee. If<em>global</em> does not designate a global object, throw a <code>TypeError</code>. Determine which global is designated by<em>global</em> using the same rules as <a href="Debugger#addDebuggee" title="The Debugger object: addDebuggee"><code>Debugger.prototype.addDebuggee</code></a>.</dd>
 <dt><code>adoptDebuggeeValue(<em>value</em>)</code></dt>
 <dd>
 <p>Given a debuggee value <code>value</code> owned by an arbitrary <code>Debugger</code>, return an equivalent debuggee value owned by this <code>Debugger</code>.</p>

 <p>If <code>value</code> is a primitive value, return it unchanged. If <code>value</code> is a <code>Debugger.Object</code> owned by an arbitrary <code>Debugger</code>, return an equivalent <code>Debugger.Object</code> owned by this <code>Debugger</code>. Otherwise, if <code>value</code> is some other kind of object, and hence not a proper debuggee value, throw a TypeError instead.</p>
 </dd>
</dl>

<h2 id="Static_methods_of_the_Debugger_Object">Static methods of the Debugger Object</h2>

<p>The functions described below are not called with a <code>this</code> value.</p>

<dl>
 <dt><code id="isCompilableUnit">isCompilableUnit(<em>source</em>)</code></dt>
 <dd>Given a string of source code, designated by<em>source</em>, return false if the string might become a valid JavaScript statement with the addition of more lines. Otherwise return true. The intent is to support interactive compilation - accumulate lines in a buffer until isCompilableUnit is true, then pass it to the compiler.</dd>
</dl>

<h4 id="Source_Metadata">Source Metadata</h4>

<dl>
 <dt>Generated from file:</dt>
 <dt> </dt>
 <dd>js/src/doc/Debugger/Debugger.md</dd>
 <dt>Watermark:</dt>
 <dd id="watermark">sha256:03b36132885e046a5f213130ba22b1139b473770f7324b842483c09ab7665f7c</dd>
 <dt>Changeset:</dt>
 <dd><a href="https://hg.mozilla.org/mozilla-central/rev/e91b2c85aacd">e91b2c85aacd</a></dd>
</dl>
